<?php

namespace CustomerManagement\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetVideoDeviceWirelessHistoryOutput StructType
 * @subpackage Structs
 */
class GetVideoDeviceWirelessHistoryOutput extends AbstractStructBase
{
    /**
     * The Success
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $Success;
    /**
     * The ErrorMessage
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ErrorMessage;
    /**
     * The WirelessHistory
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \CustomerManagement\ArrayType\ArrayOfVideoDeviceWirelessHistory
     */
    public $WirelessHistory;
    /**
     * Constructor method for GetVideoDeviceWirelessHistoryOutput
     * @uses GetVideoDeviceWirelessHistoryOutput::setSuccess()
     * @uses GetVideoDeviceWirelessHistoryOutput::setErrorMessage()
     * @uses GetVideoDeviceWirelessHistoryOutput::setWirelessHistory()
     * @param bool $success
     * @param string $errorMessage
     * @param \CustomerManagement\ArrayType\ArrayOfVideoDeviceWirelessHistory $wirelessHistory
     */
    public function __construct($success = null, $errorMessage = null, \CustomerManagement\ArrayType\ArrayOfVideoDeviceWirelessHistory $wirelessHistory = null)
    {
        $this
            ->setSuccess($success)
            ->setErrorMessage($errorMessage)
            ->setWirelessHistory($wirelessHistory);
    }
    /**
     * Get Success value
     * @return bool
     */
    public function getSuccess()
    {
        return $this->Success;
    }
    /**
     * Set Success value
     * @param bool $success
     * @return \CustomerManagement\StructType\GetVideoDeviceWirelessHistoryOutput
     */
    public function setSuccess($success = null)
    {
        // validation for constraint: boolean
        if (!is_null($success) && !is_bool($success)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($success, true), gettype($success)), __LINE__);
        }
        $this->Success = $success;
        return $this;
    }
    /**
     * Get ErrorMessage value
     * @return string|null
     */
    public function getErrorMessage()
    {
        return $this->ErrorMessage;
    }
    /**
     * Set ErrorMessage value
     * @param string $errorMessage
     * @return \CustomerManagement\StructType\GetVideoDeviceWirelessHistoryOutput
     */
    public function setErrorMessage($errorMessage = null)
    {
        // validation for constraint: string
        if (!is_null($errorMessage) && !is_string($errorMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($errorMessage, true), gettype($errorMessage)), __LINE__);
        }
        $this->ErrorMessage = $errorMessage;
        return $this;
    }
    /**
     * Get WirelessHistory value
     * @return \CustomerManagement\ArrayType\ArrayOfVideoDeviceWirelessHistory|null
     */
    public function getWirelessHistory()
    {
        return $this->WirelessHistory;
    }
    /**
     * Set WirelessHistory value
     * @param \CustomerManagement\ArrayType\ArrayOfVideoDeviceWirelessHistory $wirelessHistory
     * @return \CustomerManagement\StructType\GetVideoDeviceWirelessHistoryOutput
     */
    public function setWirelessHistory(\CustomerManagement\ArrayType\ArrayOfVideoDeviceWirelessHistory $wirelessHistory = null)
    {
        $this->WirelessHistory = $wirelessHistory;
        return $this;
    }
}
